import 'dart:io';
import 'package:dio/src/Options.dart';

/**
 * Response describes the http Response info.
 */
class Response {
  Response({this.data, this.headers, this.request, this.statusCode = 0});

  /// Response body. may have been transformed, please refer to [ResponseType].
  var data;

  /// Response headers.
  HttpHeaders headers;

  /// The corresponding request info.
  Options request;

  /// Http status code.
  int statusCode;

  /// Custom field that you can retrieve it later in `then`.
  Map<String, dynamic> extra;

  /// We care more about `data` field.
  @override
  String toString() => "[data]=" + data.toString();

}